// u_30_profiling
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_to_profile_2;
  interface
    type i_factorial=
             interface
               function f_factorial(p_n: Integer): Integer;
             end; // i_factorial

         TSomeClass=
             class(TInterfacedObject, i_factorial)
               public
                 function f_factorial(p_n: Integer): Integer;
                 procedure VirtCall(Inst: TSomeClass; p_n: Integer); virtual;
                 procedure StaticCall(Inst: TSomeClass; p_n: Integer);
                 procedure Static_recurse(p_n: Integer);
             end; // TSomeClass
  implementation

    { TSomeClass }

    procedure TSomeClass.f_factorial(p_n: Integer);
      begin
        if p_n> 0
          then Intf.f_factorial(Intf, p_n- 1);
      end; // f_factorial

    procedure TSomeClass.StaticCall(Inst: TSomeClass; p_n: Integer);
      begin
        if p_n> 0
          then StaticCall(Inst, p_n- 1);
      end; // StaticCall

    procedure TSomeClass.VirtCall(Inst: TSomeClass; p_n: Integer);
      begin
        if p_n> 0
          then VirtCall(Inst, p_n- 1);
      end; // VirtCall

    procedure TSomeClass.Static_recurse(p_n: Integer);
      begin
        if p_n> 0
          then Static_recurse(p_n- 1);
      end;
    end.
